      PROGRAM IDEMO ! Bernd Berg Apr 11 2008.
C Send and Receive (S/R) of integer arrays using two MPI processes.
C Printout to verify correct S/R.
      implicit real*8 (a-h,o-z)
      implicit logical (l)
      include 'mpif.h'
      PARAMETER(IUO=6,ITWO=2,NDAT=0512) ! Set array dimensions.
c     PARAMETER(IUO=6,ITWO=2,NDAT=1024) ! Set array dimensions.
      DIMENSION NSEND(NDAT),NRECV(NDAT),NPRNT(ITWO)
      COMMON /FOR_MPI/ ISTATUS(MPI_STATUS_SIZE)
      LTEST=.FALSE.
C
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MY_ID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,N_PROC,IERR)
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," IDEMO: N_PROC,NDAT =",2I9)') 
     &                                      N_PROC,NDAT
      IF(N_PROC.NE.2) LTEST=.TRUE.
      IF(LTEST) THEN
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"N_PROC=2 REQUIRED!")')
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"STOP IDEMO: LTEST.")')
        CALL MPI_FINALIZE(IERR)
      STOP
      ENDIF
C
      DO IDAT=1,NDAT ! Integers put into NSEND:
        NSEND(IDAT)=IDAT+MY_ID
      ENDDO
      NPRNT(1)=NSEND(1)
      NPRNT(2)=NSEND(NDAT)
      ITAG=1
      IF(MY_ID.EQ.0) WRITE(IUO,'(/,3X,"MY_ID NPRNT(1) NPRNT(2)")') 
      CALL WRITE_MPI_I(NPRNT,NRECV,ITWO,IUO,ITAG) ! Before S/R.
      ISND=MOD(MY_ID+1,N_PROC)
      IRCV=ISND
      ITAG=2
      CALL MPI_SEND(NSEND,NDAT,MPI_INTEGER,ISND,ITAG,
     &  MPI_COMM_WORLD,IERR)         ! Send to other process.
      CALL MPI_RECV(NRECV,NDAT,MPI_INTEGER,IRCV,ITAG,
     &  MPI_COMM_WORLD,ISTATUS,IERR) ! Receive from other process
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," After send/receive:")') 
      NPRNT(1)=NRECV(1)
      NPRNT(2)=NRECV(NDAT)
      CALL WRITE_MPI_I(NPRNT,NRECV,ITWO,IUO,ITAG) ! After S/R.
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," IDEMO: ALL DONE.",/)') 
C
      CALL MPI_FINALIZE(IERR)
      STOP
      END


      SUBROUTINE WRITE_MPI_I(NSEND,NRECV,NSR,IUO,itag) ! Berg Nov 11 2007.
C Purpose: Prints integer results (up to 10 integers) in a desired order.
      implicit real*8 (a-h,o-z)
      implicit logical (l)
      PARAMETER(IZERO=0,ZERO=0.D00,HALF=0.5D00,ONE=1.D00)
      INCLUDE 'mpif.h'
      DIMENSION NSEND(NSR),NRECV(NSR)
      COMMON /FOR_MPI/ ISTATUS(MPI_STATUS_SIZE)
      IF(NSR.GT.10.OR.IZERO.NE.0) THEN
        CALL MPI_FINALIZE(IERR)
      STOP "WRITE_MPI_I: NSR.GT.10.OR.IZERO.NE.0"
      ENDIF
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MY_ID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,N_PROC,IERR)
      IF(MY_ID.EQ.0) WRITE(IUO,*) "  "
      IF(MY_ID.EQ.0) WRITE(IUO,'(10I7)') IZERO,NSEND
      DO I=1,(N_PROC-1)
        IF(MY_ID.EQ.I) CALL MPI_SEND(NSEND,NSR,MPI_INTEGER,IZERO,ITAG,
     &                               MPI_COMM_WORLD,IERR)
        IF(MY_ID.EQ.0) THEN 
           CALL MPI_RECV(NRECV,NSR,MPI_INTEGER,I,ITAG,
     &                               MPI_COMM_WORLD,ISTATUS,IERR)
           WRITE(IUO,'(10I7)') I,NRECV
        END IF
      END DO
      RETURN
      END
